version: '3.7'

networks:
  paspartu-private-network:
    name: paspartu-private-network
    driver: bridge
    ipam:
      config:
        - subnet: 172.24.0.0/16
          gateway: 172.24.0.1
  paspartu-internal-network:
    name: paspartu-internal-network
  paspartu-public-network:
    name: paspartu-public-network

volumes:
  openldap_data:
    driver: local
  openldap_config:
    driver: local

services:
  openldap:
    container_name: paspartu-openldap-container
    image: osixia/openldap:latest
    hostname: openldap.cherubits.hu
    domainname: cherubits.hu
    ports:
      - '1910:1389'
      - '1911:1636'
    environment:
      LDAP_LOG_LEVEL: 32
      KEEP_EXISTING_CONFIG: true
      LDAP_REMOVE_CONFIG_AFTER_SETUP: false
      # LDAP_SSL_HELPER_PREFIX: "ldap"
      # LDAP_OPENLDAP_UID: openldap
      # LDAP_OPENLDAP_GID: openldap
    networks:
      paspartu-private-network:
        aliases:
          - openldap.cherubits.hu
        ipv4_address: 172.24.0.2
    volumes:
      - openldap_data:/var/lib/ldap
      - openldap_config:/etc/ldap/slapd.d

      - ./openldap/ldifs/custom:/container/service/slapd/assets/config/bootstrap/ldif/custom:rw
      # - ./openldap/ldifs:/container/service/sldap/assets/config/bootstrap/ldif:rw
      - ./openldap/environment:/container/environment/01-custom:rw
      # - ./openldap/bootstrap:/container/service/slapd/assets/config/bootstrap
      - ./openldap/certs:/container/service/slapd/assets/certs:rw

  phpldapadmin:
    container_name: paspartu-phpldapadmin-container
    image: osixia/phpldapadmin:latest
    hostname: phpldapadmin.cherubits.hu
    domainname: cherubits.hu
    ports:
      - '1912:80'
      - '1913:443'
    environment:
      KEEP_EXISTING_CONFIG: true
    # PHPLDAPADMIN_LDAP_HOSTS: openldap.cherubits.hu
    # PHPLDAPADMIN_SERVER_ADMIN: webmaster@cherubits.hu
    # PHPLDAPADMIN_HTTPS: true

    networks:
      paspartu-private-network:
        aliases:
          - phpldapadmin.cherubits.hu
        ipv4_address: 172.24.0.3
    depends_on:
      - openldap
    volumes:
      - ./phpldapadmin/certs/phpldapadmin:/container/service/phpldapadmin/assets/apache2/certs:rw
      - ./phpldapadmin/certs/ldap-client:/container/service/ldap-client/assets/certs:rw
      - ./phpldapadmin/environment:/container/environment/01-custom:rw
    #   - ./phpldapadmin/data:/container/service/phpldapadmin/assets/config:rw
    #   - ./phpldapadmin/certs:/container/service/ssl-tools/assets/default-ca


  # mail:
  #   # HOSTNAME: Hostname to use for container identification
  #   # SUBNET: defines a SUBNET to listen to (defaults to only 127.0.0.1). If set to e.g. 192.168, it will listen to 
  #   # all machines on the 192.168.0.0/16 subnetwork
  #   # WHITELIST_FROM: comma separated list of email addresses allowed as the originator of the mail. If set, automatically 
  #   # blacklists everything else
  #   container_name: mail-container
  #   hostname: 'mail.paspartu.cherubits.hu'
  #   build:
  #     context: ./mail
  #     dockerfile: Dockerfile
  #   networks:
  #     - paspartu-private-network
  #     - paspartu-internal-network
  #     - paspartu-public-network
    
  # openldap:
  #   container_name: paspartu-ldap-container
  #   image: bitnami/openldap:latest
  #   hostname: ldap.paspartu.cherubits.hu
  #   ports:
  #     - '1910:1389'
  #     - '1911:1636'
  #   env_file:
  #     - ./openldap/openldap.env
  #   # environment:
  #   #   - LDAP_ROOT=dc=cherubits,cd=hu
  #   #   - LDAP_ADMIN_USERNAME=admin
  #   #   - LDAP_ADMIN_PASSWORD=adminpassword
  #   #   - LDAP_CONFIG_ADMIN_ENABLED=yes
  #   #   - LDAP_USER_DC=users
  #   #   - LDAP_GROUP=accounts
  #   #   - LDAP_USERS=web2ldap,ansible
  #   #   - LDAP_PASSWORDS=qwe123,Armageddon0
  #   #   - LDAP_SKIP_DEFAULT_TREE=no
  #   #   - LDAP_CUSTOM_LDIF_DIR=/ldifs
  #   #   # - LDAP_CUSTOM_SCHEMA_FILE=/schema/custom.ldif
  #   #   - LDAP_ULIMIT_NOFILES=1024
  #   #   - LDAP_ALLOW_ANON_BINDING=yes
  #   networks:
  #     paspartu-private-network:
  #       aliases:
  #         - ldap.paspartu.cherubits.hu
  #       ipv4_address: 172.24.0.2
    
  #   volumes:
  #     - openldap_data:/bitnami/openldap
  #     - ./openldap/ldifs:/ldifs:rw
  #     - ./openldap/ldap:/etc/ldap:rw
  #     # - ./certificates:/opt/openldap/certs
  #     # - ./openldap/slapd.d:/etc/ldap/slapd.d:rw
  #     # - ./openldap/var:/var/lib/ldap:rw
  #     # - ./openldap/certs:/container/service/slapd/assets/certs/

  
  # phpldapadmin:
  #   container_name: paspartu-phpldapadmin-container
  #   image: osixia/phpldapadmin:latest
  #   hostname: phpldapadmin.paspartu.cherubits.hu
  #   ports:
  #     - '1912:80'
  #     - '1913:443'
  #   environment:
  #     - PHPLDAPADMIN_LDAP_HOSTS=openldap.paspartu.cherubits.hu
  #     - PHPLDAPADMIN_HTTPS=true
  #   networks:
  #     paspartu-private-network:
  #       aliases:
  #         - phpldapadmin.paspartu.cherubits.hu
  #       ipv4_address: 172.24.0.3
  #   # volumes:
  #   #   - ./phpldapadmin/data:/container/service/phpldapadmin/assets/config:rw
  #   #   - ./phpldapadmin/certs:/container/service/ssl-tools/assets/default-ca

  # web2ldap:
  #   container_name: paspartu-web2ldap-container
  #   build:
  #     context: ./web2ldap 
  #   depends_on:
  #     - openldap
  #   hostname: web2ldap.paspartu.cherubits.hu
  #   ports:
  #     - '1760:1760'
  #   # environment:
  #     # - WEB2LDAP_PORT=1760
  #     # - WEB2LDAP_HOST=web2ldap.paspartu.cherubits.hu
  #     # - LDAP_ADMIN_USERNAME=admin
  #     # - LDAP_ADMIN_PASSWORD=adminpassword
  #     # - LDAP_CONFIG_ADMIN_ENABLED=yes
  #     # - LDAP_USER_DC=users
  #     # - LDAP_GROUP=accounts
  #     # - LDAP_USERS=web2ldap,ansible
  #     # - LDAP_PASSWORDS=qwe123,Armageddon0
  #     # - LDAP_SKIP_DEFAULT_TREE=no
  #     # - LDAP_CUSTOM_LDIF_DIR=/ldifs
  #     # # - LDAP_CUSTOM_SCHEMA_FILE=/schema/custom.ldif
  #     # - LDAP_ULIMIT_NOFILES=1024
  #     # - LDAP_ALLOW_ANON_BINDING=yes
  #   networks:
  #     paspartu-private-network:
  #       aliases:
  #         - web2ldap.paspartu.cherubits.hu
  #       ipv4_address: 172.24.0.3
  #   volumes:
  #     # - openldap-data-volume:/bitnami/openldap
  #     - ./web2ldap/web2ldapcnf:/opt/web2ldap/etc/web2ldap/web2ldapcnf:rw
  #     # - ./openldap/slapd.d:/etc/ldap/slapd.d:rw
  #     # - ./openldap/var:/var/lib/ldap:rw
  #     # - ./openldap/certs:/container/service/slapd/assets/certs/
  # mysql:
    
  #   # MYSQL_ROOT_PASSWORD: This variable is mandatory and specifies the password that will be set for the MySQL root superuser 
  #   # account. In the above example, it was set to my-secret-pw.

  #   # MYSQL_DATABASE:  This variable is optional and allows you to specify the name of a database to be created on image startup. If a 
  #   # user/password was supplied (see below) then that user will be granted superuser access (corresponding to GRANT ALL) to this 
  #   # database.

  #   # MYSQL_USER, MYSQL_PASSWORD: These variables are optional, used in conjunction to create a new user and to set that 
  #   # user's password. This user will be granted superuser permissions (see above) for the database specified by the 
  #   # MYSQL_DATABASE variable. Both variables are required for a user to be created.

  #   # Do note that there is no need to use this mechanism to create the root superuser, that user gets created by default with the 
  #   # password specified by the MYSQL_ROOT_PASSWORD variable.

  #   # MYSQL_ALLOW_EMPTY_PASSWORD: This is an optional variable. Set to a non-empty value, like yes, to allow the container to be 
  #   # started with a blank password for the root user. NOTE: Setting this variable to yes is not recommended unless you really know 
  #   # what you are doing, since this will leave your MySQL instance completely unprotected, allowing anyone to gain complete 
  #   # superuser access.

  #   # MYSQL_RANDOM_ROOT_PASSWORD: This is an optional variable. Set to a non-empty value, like yes, to generate a random 
  #   # initial password for the root user (using pwgen). The generated root password will be printed to stdout 
  #   # (GENERATED ROOT PASSWORD: .....).

  #   # MYSQL_ONETIME_PASSWORD: Sets root (not the user specified in MYSQL_USER!) user as expired once init is complete, forcing 
  #   # a password change on first login. Any non-empty value will activate this setting. NOTE: This feature is supported on MySQL 
  #   # 5.6+ only. Using this option on MySQL 5.5 will throw an appropriate error during initialization.

  #   # MYSQL_INITDB_SKIP_TZINFO:  By default, the entrypoint script automatically loads the timezone data needed for the 
  #   # CONVERT_TZ() function. If it is not needed, any non-empty value disables timezone loading.

  #   container_name: paspartu-mysql-container
  #   image: "mysql:latest"
  #   hostname: 'database.paspartu.cherubits.hu'
  #   ports:
  #     - "3306:3306"
  #   command: --default-authentication-plugin=mysql_native_password
  #   environment:
  #     MYSQL_ROOT_PASSWORD: "admin"
  #     MYSQL_USER: "test"
  #     MYSQL_PASSWORD: "test"
  #     MYSQL_DATABASE: "test"
  #     MYSQL_ALLOW_EMPTY_PASSWORD: 1
  #   networks:
  #     - paspartu-internal-network

  # worksheet_backend:
  #   container_name: worksheet-backend-container
  #   hostname: 'backend.worksheet.paspartu.cherubits.hu'
  #   build:
  #     context: ./worksheet/backend
  #     dockerfile: Dockerfile
  #   ports:
  #     - "3000:3000"
  #   networks:
  #     - paspartu-private-network
  #     - paspartu-internal-network
  #     - paspartu-public-network

  # worksheet_frontend:
  # container_name: worksheet-frontend-container
  # hostname: 'frontend.worksheet.paspartu.cherubits.hu'
  # build:
  #   context: ./worksheet/backend
  #   dockerfile: Dockerfile
  # ports:
  #   - "3000:3000"
  # networks:
  #   - paspartu-public-network